unit asaKbdLayReg;

interface

procedure Register;

implementation
uses
  Classes, DsgnIntf, KbdLay, KbdDsgn, asaCDlg;

{$R *.DCR}

type
  TKbdLayProperty = class(TEnumProperty)
    function GetValue: string; override;
    procedure GetValues(Proc: TGetStrProc); override;
    procedure SetValue(const Value: string); override;
  end;

function TKbdLayProperty.GetValue: string;
begin
  Result := TKbdLayout(GetComponent(0)).GetLayoutName(GetOrdValue);
end;

procedure TKbdLayProperty.GetValues(Proc: TGetStrProc);
var
  I: LongInt;
  Kbd: TKbdLayout;
begin
  Kbd := TKbdLayout(GetComponent(0));
  for I := 0 to Kbd.LayoutCount-1 do
    Proc(Kbd.GetLayoutName(I));
end;

procedure TKbdLayProperty.SetValue(const Value: string);
var
  I: Integer;
begin
  I := TKbdLayout(GetComponent(0)).LayoutNameIndex(Value);
  if I <> -1 then
    SetOrdValue(I);
end;
//
type
  TControlLayoutsEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure TControlLayoutsEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then begin
    EditControlsLayouts(Component as TControlLayouts);
  end;
end;

function TControlLayoutsEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'ControlLaout List ...';
    else Result := '';
  end;
end;

function TControlLayoutsEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;
//
type
  TasaAboutBoxEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure TasaAboutBoxEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then begin
    (Component as TasaAboutBox).Execute;
  end;
end;

function TasaAboutBoxEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'About Box testing ...';
    else Result := '';
  end;
end;

function TasaAboutBoxEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;
//
procedure Register;
begin
  RegisterComponents('ASA',[TKbdLayout, TControlLayouts]);
  //
  RegisterPropertyEditor(TypeInfo(LongInt), TKbdLayout, 'CurLayout', TKbdLayProperty);
  RegisterComponentEditor(TControlLayouts, TControlLayoutsEditor);
  RegisterComponentEditor(TasaAboutBox, TasaAboutBoxEditor);
end;

end.
